#
# tk  basic cab module
#
# $Id: cab-basic.tcl,v 1.1 1997/05/26 16:47:44 bri Exp $
#

set cab basic

# this is a bunch of stuff to be used later on by the graphics routines.
# anything in the var p_BASIC is visible to the world and should not change,
# anything else may be, but we don't care what happens to it.

set p_BASIC(size_x) 200
set p_BASIC(size_y) [expr $p_BASIC(size_x) * 0.5]

# create a cab
proc cab_create_$cab {w} {
    global cab_number p_BASIC lok_addr_prev lok_addr

    set addr $lok_addr($w)

    scale $w.la -from 0 -to 20 -resolution 1 -orient horizontal \
	-showvalue true -sliderlength 20 -variable lok_addr($w) \
	-command "chaddr $w"

    pack $w.la -side bottom -fill x

    canvas $w.c -width $p_BASIC(size_x) -height $p_BASIC(size_y)
    set p_BASIC(size_x,$w) $p_BASIC(size_x)
    set p_BASIC(size_y,$w) $p_BASIC(size_y)

    pack $w.c -side right -fill both -expand true

    add_cab $w $addr
    init_canvas_basic $w
    bind $w.c <Configure> "refig_basic $w %w %h"

    return $w
}

proc refig_basic {w x y} {
    global p_BASIC
    set p_BASIC(size_x,$w) $x
    set p_BASIC(size_y,$w) $y
    init_canvas_basic $w
    update_cab_basic $w
#    puts stdout "$x $y"
}

# set up the cab's canvas

proc init_canvas_$cab {w} {
    global p_BASIC cab_state pi_3_2 pi_4

    set x $p_BASIC(size_x,$w)
    set y $p_BASIC(size_y,$w)

    set c $w.c
    $c delete all

    # light

    set light_pos_x [expr $x * .65]
    set light_pos_y [expr $y * .75]
    set light_x [expr $x * .075]
    set light_y [expr $y * .15]

    $c create oval \
	[expr $light_pos_x - $light_x] \
	[expr $light_pos_y - $light_y] \
	[expr $light_pos_x + $light_x] \
	[expr $light_pos_y + $light_y] \
	    -outline black -width 3 -fill white -tags {lights lightson}

    $c create oval \
	[expr $light_pos_x - $light_x] \
	[expr $light_pos_y - $light_y] \
	[expr $light_pos_x + $light_x] \
	[expr $light_pos_y + $light_y] \
	    -outline black -width 3 -fill darkgrey -tags {lights lightsoff}

    $c bind lights <1> "swap_function $w"

    # direction indicator

    set d_cx [expr $x * .25]
    set d_cy [expr $y * .75]
    set d_l [expr $x * .18]
    set d_w [expr $y * .03]
    set d_list [list [expr $x * .05] [expr $x * .07] [expr $y * .05]]
    set dir_x [expr $x * .20]
    set dir_y [expr $y * .10]

    $c create polygon \
	[expr $d_cx - $dir_x] [expr $d_cy - $dir_y] \
	[expr $d_cx + $dir_x] [expr $d_cy - $dir_y] \
	[expr $d_cx + $dir_x] [expr $d_cy + $dir_y] \
	[expr $d_cx - $dir_x] [expr $d_cy + $dir_y] \
	    -outline black -fill grey -tags dirbox

    $c create line \
	[expr $d_cx - $d_l] $d_cy [expr $d_cx + $d_l] $d_cy -width $d_w \
	    -arrowshape $d_list -arrow last -tags {left arrows dirbox}
    $c create line \
	[expr $d_cx + $d_l] $d_cy [expr $d_cx - $d_l] $d_cy -width $d_w \
	    -arrowshape $d_list -arrow last -tags {right arrows dirbox}

    $c bind dirbox <1> "swap_direction $w"

    # speed

    set p_BASIC(sp_sx,$w) [expr $x * .15]
    set p_BASIC(sp_sy,$w) [expr $y * .10]
    set p_BASIC(sp_x,$w) [expr $x * .70]
    set p_BASIC(sp_y,$w) [expr $y * .30]

    $c create polygon \
	$p_BASIC(sp_sx,$w) $p_BASIC(sp_sy,$w) \
	[expr $p_BASIC(sp_sx,$w) + $p_BASIC(sp_x,$w)] $p_BASIC(sp_sy,$w) \
	[expr $p_BASIC(sp_sx,$w) + $p_BASIC(sp_x,$w)] \
	    [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_y,$w)] \
	$p_BASIC(sp_sx,$w) [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_y,$w)] \
	    -outline black -fill grey -tags speedo

    $c create polygon \
	$p_BASIC(sp_sx,$w) $p_BASIC(sp_sy,$w) \
	$p_BASIC(sp_sx,$w) $p_BASIC(sp_sy,$w) \
	$p_BASIC(sp_sx,$w) $p_BASIC(sp_sy,$w) \
	$p_BASIC(sp_sx,$w) $p_BASIC(sp_sy,$w) \
	    -outline black -fill black -tags {meter speedo}

    $c bind speedo <B1-Motion> "getval_basic $w %x %y"
    $c bind speedo <1> "getval_basic $w %x %y"

    set x_p [expr $x * .02]
    set x_l [expr $x * .07]

    $c create polygon \
	[expr $p_BASIC(sp_sx,$w) - $x_p] $p_BASIC(sp_sy,$w) \
	[expr $p_BASIC(sp_sx,$w) - $x_p - $x_l] \
	    [expr $p_BASIC(sp_sy,$w) + ($p_BASIC(sp_y,$w)/2.0)] \
	[expr $p_BASIC(sp_sx,$w) - $x_p] \
	    [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_y,$w)] \
	    -outline black -fill white -tags {dec}

    $c create polygon \
	[expr $p_BASIC(sp_sx,$w) + $x_p + $p_BASIC(sp_x,$w)] $p_BASIC(sp_sy,$w) \
	[expr $p_BASIC(sp_sx,$w) + $x_p + $x_l + $p_BASIC(sp_x,$w)] \
	    [expr $p_BASIC(sp_sy,$w) + ($p_BASIC(sp_y,$w)/2.0)] \
	[expr $p_BASIC(sp_sx,$w) + $x_p + $p_BASIC(sp_x,$w)] \
	    [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_y,$w)] \
	    -outline black -fill white -tags {inc}

    $c bind dec <1> "incr_loco $w -1 ; %W itemconfig dec -fill red"
    $c bind inc <1> "incr_loco $w 1 ; %W itemconfig inc -fill red"
    $c bind dec <ButtonRelease-1> { %W itemconfig dec -fill grey }
    $c bind inc <ButtonRelease-1> { %W itemconfig inc -fill grey }
    $c bind dec <Enter> { %W itemconfig dec -fill grey }
    $c bind dec <Leave> { %W itemconfig dec -fill white }
    $c bind inc <Enter> { %W itemconfig inc -fill grey }
    $c bind inc <Leave> { %W itemconfig inc -fill white }

    set p_BASIC(sp_noy,$w) [expr $y * .01 + $p_BASIC(sp_y,$w)]

    set cab_state($w,dir) -1
    set cab_state($w,speed) -1
    set cab_state($w,func) -1
    set cab_state($w,speed_max) 14
}

proc getval_basic {w x y} {
    global p_BASIC lok_addr speed speed_max
    set la $lok_addr($w)
    set max $speed_max($la)
    set sp [expr int($max * 1.0 * (($x - $p_BASIC(sp_sx,$w))/$p_BASIC(sp_x,$w)))]
    if {$sp > $max} {
	set sp $max
    } elseif {$sp < 0} {
	set sp 0
    }
    if {$speed($lok_addr($w)) != $sp} {
	set speed($lok_addr($w)) $sp
	move_loco $w
    }
}

proc incr_loco {w i} {
    global speed speed_max lok_addr
    set la $lok_addr($w)
    incr speed($la) $i
    if {$speed($la) > $speed_max($la)} {
	set speed($la) $speed_max($la)
    } elseif {$speed($la) < 0} {
	set speed($la) 0
    }
    move_loco $w
}

# provide for click-to-set-speed

# update a cab

proc update_cab_$cab {w} {
    global p_BASIC cab_state lok_addr speed speed_max direction functions speed.$w

    set la $lok_addr($w)
    set max $speed_max($la)

    set c $w.c

    if {$cab_state($w,speed_max) != $speed_max($la)} {
	set cab_state($w,speed_max) $speed_max($la)
    }

    set speed.$w $speed($la)
    set v $speed($la)

    if {$cab_state($w,speed) != $v} {
	set cab_state($w,speed) $v
	set x [expr $p_BASIC(sp_sx,$w) + $p_BASIC(sp_x,$w) * $speed($la) /(1.0 * $speed_max($la))]
	$c coords meter \
	    $p_BASIC(sp_sx,$w) $p_BASIC(sp_sy,$w) \
	    $x $p_BASIC(sp_sy,$w) \
	    $x [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_y,$w)] \
	    $p_BASIC(sp_sx,$w) [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_y,$w)]

	$c delete spnum
	$c create text $x [expr $p_BASIC(sp_sy,$w) + $p_BASIC(sp_noy,$w)] \
	    -tags spnum -anchor n -justify center -text $v
    }

    if {$cab_state($w,dir) != $direction($la)} {
	$c lower arrows
	if {$direction($la)} {
	    $c raise left
	} else {
	    $c raise right
	}
    }

    if {$cab_state($w,func) != $functions($la)} {
	if {$functions($la)} {
	    $c lower lightsoff
	    $c raise lightson
	} else {
	    $c lower lightson
	    $c raise lightsoff
	}
	set cab_state($w,func) $functions($la)
    }
}

