#
# tk eurocab module
#
# $Id: cab-euro1.tcl,v 1.4 1997/05/26 16:48:41 bri Exp $
#

set cab euro1

# this is a bunch of stuff to be used later on by the graphics routines.
# anything in the var p_EURO1 is visible to the world and should not change,
# anything else may be, but we don't care what happens to it.

set p_EURO1(size_x) 200
set p_EURO1(size_y) [expr $p_EURO1(size_x) * 1.5]

set p_EURO1(d_pos_y) [expr $p_EURO1(size_x) * 1.10]
set p_EURO1(d_pos_x) [expr $p_EURO1(size_x) / 2]

set p_EURO1(circle_offset) [expr $pi - $pi_8 - ($pi_3_2 / 28.0)]

set p_EURO1(sp_c_x) [expr $p_EURO1(size_x) / 2]
set p_EURO1(sp_c_y) [expr $p_EURO1(size_x) / 2]
set sp_c_x $p_EURO1(sp_c_x)
set sp_c_y $p_EURO1(sp_c_y)

set sp_s_x [expr $p_EURO1(size_x) / 6]
set sp_s_y [expr $p_EURO1(size_x) / 6]

set sp_flc_x [expr ($p_EURO1(size_x) / 2) - $p_EURO1(size_x) / 4.5]
set sp_flc_y [expr ($p_EURO1(size_x) / 2) - $p_EURO1(size_x) / 4.5]

set p_EURO1(sp_circ_diam) [expr $p_EURO1(size_x) / 15]
set sp_circ_off [expr $p_EURO1(sp_circ_diam) / 2]

set sp_f_l_x [expr $sp_flc_x - $sp_circ_off ]
set sp_f_l_y [expr $sp_flc_y - $sp_circ_off ]

set sp_s_p_x [expr $sp_flc_x + $sp_circ_off]
set sp_s_p_y [expr $sp_flc_y + $sp_circ_off]

set arrow_len [expr $p_EURO1(size_x) / 25]
set p_EURO1(arrow_list) [list $arrow_len $arrow_len 1]

set p_EURO1(d_arrow_list) {12 20 9}

set sp_f_p_x [expr $sp_flc_x + $sp_circ_off + $p_EURO1(size_x) / 10]
set sp_f_p_y [expr $sp_flc_y + $sp_circ_off + $p_EURO1(size_x) / 10]
set p_EURO1(s_o_x) $sp_f_p_x
set p_EURO1(s_o_y) $sp_f_p_y

foreach j {14 27 28} {
    set i 0
    while { $i <= $j } {
	set sin_val($i) [expr sin($pi_3_2 * $i / $j - $pi_4)]
	set cos_val($i) [expr cos($pi_3_2 * $i / $j - $pi_4)]

	set p_EURO1(spfx_$i.$j) [expr $sp_c_x + $sp_s_x * $cos_val($i)]
	set p_EURO1(spfy_$i.$j) [expr $sp_c_y + $sp_s_y * $sin_val($i)]
	set p_EURO1(sptx_$i.$j) [expr $sp_c_x - $sp_f_l_x * $cos_val($i)]
	set p_EURO1(spty_$i.$j) [expr $sp_c_y - $sp_f_l_y * $sin_val($i)]

	set p_EURO1(spofx_$i.$j) [expr $sp_c_x - $sp_s_p_x * $cos_val($i)]
	set p_EURO1(spofy_$i.$j) [expr $sp_c_y - $sp_s_p_y * $sin_val($i)]
	set p_EURO1(spotx_$i.$j) [expr $sp_c_x - $sp_f_p_x * $cos_val($i)]
	set p_EURO1(spoty_$i.$j) [expr $sp_c_y - $sp_f_p_y * $sin_val($i)]

	set p_EURO1(scx_$i.$j) [expr $sp_c_x - $sp_circ_off - $sp_flc_x * $cos_val($i)]
	set p_EURO1(scy_$i.$j) [expr $sp_c_y - $sp_circ_off - $sp_flc_y * $sin_val($i)]

	incr i
    }
    incr j
}


# create a cab

proc cab_create_euro1 {w} {
    global cab_number p_EURO1 lok_addr_prev lok_addr

    set addr $lok_addr($w)

    scale $w.t -from 14 -to 0 -resolution 1 -orient vertical -showvalue true \
	-sliderlength 15 -variable speed.$w -width 20 \
	-command "chspeed $w"

    scale $w.la -from 0 -to 20 -resolution 1 -orient horizontal \
	-showvalue true -sliderlength 20 -variable lok_addr($w) \
	-command "chaddr $w"

    pack $w.t -side left -fill y
    pack $w.la -side bottom -fill x

    canvas $w.c -width $p_EURO1(size_x) -height $p_EURO1(size_y)

    pack $w.c -side right

    add_cab $w $addr
    init_canvas_euro1 $w

    return $w
}


# set up the cab's fancy canvas

proc init_canvas_euro1 {w} {
    global p_EURO1 cab_state pi_3_2 pi_4

    # some initial parms

    # this sets how many ticks there will be
    set num_ticks 14
    set i 0
    while { $i <= $num_ticks } {
	set sin_val($i) [expr sin($pi_3_2 * $i / $num_ticks - $pi_4)]
	set cos_val($i) [expr cos($pi_3_2 * $i / $num_ticks - $pi_4)]
	incr i
    }

    set light_pos_y [expr $p_EURO1(size_x) * 1.25]
    set light_box_height [expr $p_EURO1(size_x) * .20]
    set light_box_pos_x [expr $p_EURO1(size_x) * .1]
    set light_diam [expr $p_EURO1(size_x) * .15]
    set light_pos_x [expr $p_EURO1(size_x) * .2]
    set light_arc_diam [expr $p_EURO1(size_x) * .11]

    set center_c_w [expr $p_EURO1(size_x) / 20 ]

    set other_len [expr $p_EURO1(size_x) / 25]
    set outer_dial_off [expr $p_EURO1(size_x) / 30 + $other_len]

    set c $w.c

    # the meter

    $c create oval \
	[expr $p_EURO1(sp_c_x) - $center_c_w] \
	[expr $p_EURO1(sp_c_y) - $center_c_w] \
	[expr $p_EURO1(sp_c_x) + $center_c_w] \
	[expr $p_EURO1(sp_c_y) + $center_c_w] \
		-tags {center move_meter} -width 3 -fill black -outline grey

    $c create oval \
	[expr $p_EURO1(sp_c_x) - $p_EURO1(s_o_x) - $outer_dial_off] \
	[expr $p_EURO1(sp_c_y) - $p_EURO1(s_o_x) - $outer_dial_off] \
	[expr $p_EURO1(sp_c_x) + $p_EURO1(s_o_x) + $outer_dial_off] \
	[expr $p_EURO1(sp_c_y) + $p_EURO1(s_o_x) + $outer_dial_off] \
	    -tags {bottom move_meter} -width 2 -fill white -outline black

    set i 0
    while { $i <= $num_ticks } {
	$c create text \
	    [expr $p_EURO1(sp_c_x) - $p_EURO1(s_o_x) * $cos_val($i)] \
	    [expr $p_EURO1(sp_c_y) - $p_EURO1(s_o_y) * $sin_val($i)] \
		-anchor center -fill blue -tags {bottom move_meter} -text $i
	$c create line \
	    [expr $p_EURO1(sp_c_x) - ($p_EURO1(s_o_x) + $other_len) * $cos_val($i)] \
	    [expr $p_EURO1(sp_c_y) - ($p_EURO1(s_o_y) + $other_len) * $sin_val($i)] \
	    [expr $p_EURO1(sp_c_x) - ($p_EURO1(s_o_x) + $outer_dial_off) * $cos_val($i)] \
	    [expr $p_EURO1(sp_c_y) - ($p_EURO1(s_o_y) + $outer_dial_off) * $sin_val($i)] \
		-tags {bottom move_meter} -width 1
	incr i
    }

    $c create oval 0 0 $p_EURO1(sp_circ_diam) $p_EURO1(sp_circ_diam) -tags \
	    {speedcirc move_meter} -width 3

    $c lower bottom

    # the lights

    $c create rectangle $light_box_pos_x $light_pos_y \
	[expr $p_EURO1(size_x) - $light_box_pos_x] \
	[expr $light_pos_y + $light_box_height] \
	  -outline black -fill darkblue -tags lights

    set lightdiff [expr ($light_box_height - $light_diam) / 2.0]

    $c create oval $light_pos_x [expr $light_pos_y + $lightdiff] \
	[expr $light_pos_x + $light_diam] \
	[expr $light_pos_y + $lightdiff + $light_diam] \
	    -outline black -width 3 -fill white -tags {lights lightson}

    $c create oval \
	[expr $p_EURO1(size_x) - $light_pos_x - $light_diam] \
	[expr $light_pos_y + $lightdiff] \
	[expr $p_EURO1(size_x) - $light_pos_x] \
	[expr $light_pos_y + $lightdiff + $light_diam] \
	    -outline black -width 3 -fill white -tags {lights lightson}

    $c create oval $light_pos_x [expr $light_pos_y + $lightdiff] \
	[expr $light_pos_x + $light_diam] \
	[expr $light_pos_y + $lightdiff + $light_diam] \
	    -outline black -width 3 -fill darkgrey -tags {lights lightsoff}

    $c create oval \
	[expr $p_EURO1(size_x) - $light_pos_x - $light_diam] \
	[expr $light_pos_y + $lightdiff] \
	[expr $p_EURO1(size_x) - $light_pos_x] \
	[expr $light_pos_y + $lightdiff + $light_diam] \
	    -outline black -width 3 -fill darkgrey -tags {lights lightsoff}

    # now this is a lot of fluff, but it looks pretty.

    set arcdiff [expr ($light_diam - $light_arc_diam) / 2.0]

    $c create arc [expr $light_pos_x + $arcdiff] \
	[expr $light_pos_y + $lightdiff + $arcdiff] \
	[expr $light_pos_x + $light_diam - $arcdiff] \
	[expr $light_pos_y + $lightdiff + $light_diam - $arcdiff] \
	    -outline white -width 2 -tags {lights lightsarc} -style arc \
	    -start -15 -extent 100

    $c create arc \
	[expr $p_EURO1(size_x) - $light_pos_x - $light_diam + $arcdiff] \
	[expr $light_pos_y + $lightdiff + $arcdiff] \
	[expr $p_EURO1(size_x) - $light_pos_x - $arcdiff] \
	[expr $light_pos_y + $lightdiff + $light_diam - $arcdiff] \
	    -outline white -width 2 -tags {lights lightsarc} -style arc \
	    -start -15 -extent 100

    $c bind lights <1> "swap_function $w"

    $c bind move_meter <B1-Motion> "getval_euro1 $w %x %y"
    $c bind move_meter <1> "getval_euro1 $w %x %y"

    button $c.d -bitmap @arrows.xbm -command "swap_direction $w"
    $c create window $p_EURO1(d_pos_x) $p_EURO1(d_pos_y) -window $c.d -anchor center

    set cab_state($w,dir) -1
    set cab_state($w,speed) -1
    set cab_state($w,func) -1
    set cab_state($w,speed_max) 14
}


# provide for click-to-set-speed

proc getval_euro1 {w x y} {
    global p_EURO1 pi_3_2 lok_addr speed speed_max

    # XXX this can be done with a lot fewer instructions. at the moment it
    # is cheap enough because we don't do anything when there is no change
    # in speed.

    set la $lok_addr($w)
    set max $speed_max($la)

    set xx [expr $p_EURO1(sp_c_x) - $x]
    set yy [expr $p_EURO1(sp_c_y) - $y]
    if {$xx != 0 && $yy !=0} {
	set atan [expr - atan2($xx,$yy)]
	set speedstep [expr int((($atan + $p_EURO1(circle_offset)) / $pi_3_2) * $max)]
	if {$speedstep < 0} {
	    set speedstep 0
	} elseif {$speedstep > $speed_max($la)} {
	    set speedstep $speed_max($la)
	}
#	puts stdout "$w $atan $speedstep"
	if {$speed($lok_addr($w)) != $speedstep} {
	    set speed($lok_addr($w)) $speedstep
	    move_loco $w
	}
    }
}

# update a cab

proc update_cab_$cab {w} {
    global p_EURO1 cab_state lok_addr speed speed_max direction functions speed.$w

    set la $lok_addr($w)
    set max $speed_max($la)

    set c $w.c

    if {$cab_state($w,speed_max) != $speed_max($la)} {
	$w.t config -from $speed_max($la)
	set cab_state($w,speed_max) $speed_max($la)
    }

    set speed.$w $speed($la)
    set v $speed($la)

    if {$cab_state($w,speed) != $v} {
	if {$v < 0} {
	    addmsg .textinfo "$la: speed $v\n"
	    set v 0
	}

	$c delete speedo

	set foo [split [$c coords speedcirc]]

	$c move speedcirc [expr $p_EURO1(scx_$v.$max) - [lindex $foo 0]] \
			  [expr $p_EURO1(scy_$v.$max) - [lindex $foo 1]]
    
	$c create line $p_EURO1(spfx_$v.$max) $p_EURO1(spfy_$v.$max) \
	    $p_EURO1(sptx_$v.$max) $p_EURO1(spty_$v.$max) \
	    -tags "speedo move_meter" -width 3

	$c create line $p_EURO1(spofx_$v.$max) $p_EURO1(spofy_$v.$max) \
		       $p_EURO1(spotx_$v.$max) $p_EURO1(spoty_$v.$max) \
	   -tags {speedo move_meter} -width 3 -arrow last -arrowshape $p_EURO1(arrow_list)
	set cab_state($w,speed) $v
    }

    if {$cab_state($w,dir) != $direction($la)} {
	$c delete direction

	if {$direction($la)} {
	   $c create line \
	  [expr $p_EURO1(d_pos_x) + ($p_EURO1(size_x) / 5)] $p_EURO1(d_pos_y) \
	  [expr $p_EURO1(size_x) - ($p_EURO1(size_x) / 10)] $p_EURO1(d_pos_y) \
	-arrow last -arrowshape $p_EURO1(d_arrow_list) -width 5 -tags direction
	} else {
	   $c create line \
	  [expr $p_EURO1(d_pos_x) - ($p_EURO1(size_x) / 5)] $p_EURO1(d_pos_y) \
	  [expr ($p_EURO1(size_x) / 10)] $p_EURO1(d_pos_y) \
	-arrow last -arrowshape $p_EURO1(d_arrow_list) -width 5 -tags direction
	}
	set cab_state($w,dir) $direction($la)
    }

    if {$cab_state($w,func) != $functions($la)} {
	if {$functions($la)} {
	    $c lower lightsoff
	    $c raise lightson
	} else {
	    $c lower lightson
	    $c raise lightsoff
	}
	$c raise lightsarc
	set cab_state($w,func) $functions($la)
    }
}

