#
# tk cab module
#
# $Id: tkcab.tcl,v 1.4 1997/05/26 16:47:03 bri Exp $
#

source cab-euro1.tcl
source cab-basic.tcl

set direction(0) 0
set functions(0) 0
set speed(0) 0

set cab_number 0

proc create_new_cab {addr type} {
    global cab_number can_size can_size_y lok_addr_prev lok_addr cab_type

    incr cab_number

    set w .cab$cab_number
    set lok_addr($w) $addr
    set lok_addr_prev($w) $addr
    set cab_type($w) $type

    toplevel $w
    bind $w <Destroy> "clean_cab $w %W"

    set type [cab_create_$type $w]
    return $type
}

proc clean_cab {w ww} {
    global lok_addr
    # because we get all the events, not just the top (argh).
    if {$w == $ww} {	
	rm_cab $ww $lok_addr($ww)
	addmsg .textinfo "cab deleted: $ww\n"
    }
}

proc chspeed {w s} {
    global speed lok_addr
    set speed($lok_addr($w)) $s
    move_loco $w
}

proc swap_direction {w} {
    global direction lok_addr speed
    set la $lok_addr($w)
    set direction($la) [expr ! $direction($la)]
    set speed($la) 0
    move_loco $w
}

proc swap_function {w} {
    global functions lok_addr
    set la $lok_addr($w)
    set functions($la) [expr ! $functions($la)]
    move_loco $w
}

proc move_loco {w} {
    global lok_addr direction functions speed speed_max FD
    set la $lok_addr($w)
    update_cabs $la
    if {$lok_addr($w) != 0} {
#	puts stdout "lc $la $direction($la) $speed($la) $functions($la) $speed_max($la)"
	puts $FD "lc $lok_addr($w) $direction($la) $speed($la) $functions($la) $speed_max($la)"
	flush $FD
    }
}

proc move_loco_by_num {la} {
    global lok_addr direction functions speed speed_max FD
    update_cabs $la
    if {$la != 0} {
#	puts stdout "lc $la $direction($la) $speed($la) $functions($la) $speed_max($la)"
	puts $FD "lc $la $direction($la) $speed($la) $functions($la) $speed_max($la)"
	flush $FD
    }
}

proc rm_cab {w n} {
    global widget_list
    regsub -all "$w " $widget_list($n) "" widget_list($n)
#    puts stdout "rm $w $n: $widget_list($n)FOO"
}

proc add_cab {w n} {
    global widget_list
    append widget_list($n) "$w "
#    puts stdout "add $w $n: $widget_list($n)FOO"
}

proc chaddr {w addr} {
    global lok_addr lok_addr_prev speed speed_max direction lights functions FD

    rm_cab $w $lok_addr_prev($w)
    set lok_addr_prev($w) $lok_addr($w)

#    set lok_addr($w) $addr
#    puts stdout "there"

    add_cab $w $lok_addr($w)

    if {[catch {set speed($addr)}]} {
	set speed($addr) 0
	set functions($addr) 0
	set direction($addr) 0
	set speed_max($addr) 14
    }

    if {$lok_addr($w) != 0} {
	puts $FD "li $lok_addr($w)"
	flush $FD
    }

    # XXX -- this gets chucked as soon as I get the different speeds

#    $w.t config -variable speed($addr)
#    $w.t config -from $speed_max($addr)
}

proc update_cabs {addr} {
    global widget_list cab_type
    foreach widget [split [string trim $widget_list($addr)]] {
	if {[catch {update_cab_$cab_type($widget) $widget}]} {
	    global lok_addr speed speed_max direction functions
#	    puts stdout "everywhere $widget"
	    set la $lok_addr($widget)
	    addmsg .textinfo "error: a $la v $speed($la) m $speed_max($la) d $direction($la)\n"
	    rm_cab $widget $addr
	}
    }
}

set i 0    
while { $i <= 150 } {
    set widget_list($i) ""
    incr i
}       

